package org.silverpeas.mobile.shared.services.rest;

import static org.fusesource.restygwt.client.AbstractJsonEncoderDecoder.*;

public class ServiceTask_Generated_RestServiceProxy_ implements org.silverpeas.mobile.shared.services.rest.ServiceTask, org.fusesource.restygwt.client.RestServiceProxy {
  private org.fusesource.restygwt.client.Resource resource = null;
  
  public void setResource(org.fusesource.restygwt.client.Resource resource) {
    this.resource = resource;
  }
  public org.fusesource.restygwt.client.Resource getResource() {
    if (this.resource == null) {
      String serviceRoot = org.fusesource.restygwt.client.Defaults.getServiceRoot();
      this.resource = new org.fusesource.restygwt.client.Resource(serviceRoot).resolve("/mobile/personalTask");
    }
    return this.resource;
  }
  private org.fusesource.restygwt.client.Dispatcher dispatcher = null;
  
  public void setDispatcher(org.fusesource.restygwt.client.Dispatcher dispatcher) {
    this.dispatcher = dispatcher;
  }
  
  public org.fusesource.restygwt.client.Dispatcher getDispatcher() {
    return this.dispatcher;
  }
  public void createTask(org.silverpeas.mobile.shared.dto.TaskDTO task, org.fusesource.restygwt.client.MethodCallback<org.silverpeas.mobile.shared.dto.TaskDTO> callback) {
    final org.silverpeas.mobile.shared.dto.TaskDTO final_task = task;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("")
    .post();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(org.silverpeas.mobile.shared.dto.TaskDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(task));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<org.silverpeas.mobile.shared.dto.TaskDTO>(__method, callback) {
        protected org.silverpeas.mobile.shared.dto.TaskDTO parseResult() throws Exception {
          try {
            return org.silverpeas.mobile.shared.dto.TaskDTO_Generated_JsonEncoderDecoder_.INSTANCE.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void deleteTasks(java.util.List<org.silverpeas.mobile.shared.dto.TaskDTO> tasks, org.fusesource.restygwt.client.MethodCallback<java.lang.Void> callback) {
    final java.util.List<org.silverpeas.mobile.shared.dto.TaskDTO> final_tasks = tasks;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("")
    .delete();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(toJSON(tasks, org.silverpeas.mobile.shared.dto.TaskDTO_Generated_JsonEncoderDecoder_.INSTANCE));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Void>(__method, callback) {
        protected java.lang.Void parseResult() throws Exception {
          return (java.lang.Void) null;
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void loadTasks(org.fusesource.restygwt.client.MethodCallback<java.util.List<org.silverpeas.mobile.shared.dto.TaskDTO>> callback) {
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("all")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.util.List<org.silverpeas.mobile.shared.dto.TaskDTO>>(__method, callback) {
        protected java.util.List<org.silverpeas.mobile.shared.dto.TaskDTO> parseResult() throws Exception {
          try {
            return toList(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()), org.silverpeas.mobile.shared.dto.TaskDTO_Generated_JsonEncoderDecoder_.INSTANCE);
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void updateTask(org.silverpeas.mobile.shared.dto.TaskDTO task, org.fusesource.restygwt.client.MethodCallback<java.lang.Void> callback) {
    final org.silverpeas.mobile.shared.dto.TaskDTO final_task = task;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("")
    .put();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(org.silverpeas.mobile.shared.dto.TaskDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(task));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Void>(__method, callback) {
        protected java.lang.Void parseResult() throws Exception {
          return (java.lang.Void) null;
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
}
